package DAS;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.rmi.RemoteException;
import java.util.Properties;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.rpc.ServiceException;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.china.vo.das.engine.client.DASClient;
import org.china.vo.das.engine.impl.DASNamespaces;
import org.globus.wsrf.encoding.DeserializationException;
import org.globus.wsrf.encoding.ObjectDeserializer;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.encoding.SerializationException;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class Asyn {
	private String args[];

	private Integer format;

	private DASClient dasClient;

	public void asynQ(String[] args) throws DeserializationException,
			IOException, ParserConfigurationException, SAXException {
		if (args.length == 2) {
			if (args[1].toLowerCase().equals("-help")) {
				String asynHelp = "usage: asyn <adql|-f <adql file>> <format> <url> <fileName>\n"
						+ "Each option explained below:\n"
						+ "  adql          --  the adql query sentence submitted by user\n "
						+ " -f <adqlFile> -- the file containning adql query sentence\n"
						+ "  format        -- one of 0,1,2,3 \n"
						+ "                 0 : CSV with comma\n"
						+ "                 1 : CSV with TAB\n "
						+ "                2 : VOTable \n "
						+ "                3 : FITS \n"
						+ "  url           -- saving address of query result \n"
						+ "  fileName      -- saving the query object and the name should be unique identification";
				System.out.println(asynHelp);
			} else System.out.println("the parameter is error");
		} else {
			Properties props = new Properties();
			FileInputStream in = new FileInputStream("server.properties");
			props.load(in);
			in.close();

			String serverIP = props.getProperty("das.server");
			String port = props.getProperty("das.port");
           System.out.println("it is connecting to the server");
			Connect doConnect = new Connect(serverIP, port);
			int connected = doConnect.isConnect();
			if (connected == 1) {
				if (args.length == 5) {
					if (args[2].equals("0") | args[2].equals("1")
							| args[2].equals("2") | args[2].equals("3")) {
						format = Integer.parseInt(args[2]);
						Connect.dasClient.AsynchQuery(args[1], format, args[3]);
						try {
							String endpointString = ObjectSerializer.toString(
									Connect.dasClient.getinstanceEPR(),
									DASNamespaces.RESOURCE_REFERENCE);
							FileWriter fileWriter = new FileWriter(args[4]);
							BufferedWriter bfWriter = new BufferedWriter(
									fileWriter);
							bfWriter.write(endpointString);
							bfWriter.close();
						} catch (SerializationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					} else {
						System.out.println("it is error!");
					}
				} else if (args.length == 6
						& args[1].toLowerCase().endsWith("-f")) {
					String readStr = "", read;
					if (args[3].equals("0") | args[3].equals("1")
							| args[3].equals("2") | args[3].equals("3")) {
						format = Integer.parseInt(args[3]);
						File file = new File(args[2]);
						if (file.exists()) {
							try {
								FileReader fileread = new FileReader(file);
								BufferedReader bufread = new BufferedReader(
										fileread);
								while ((read = bufread.readLine()) != null) {
									readStr = readStr + read;
								}
							} catch (Exception d) {
							}
							String ADQL = readStr;

							try {
	                            System.out.println("it is submitting ADQL");
								Connect.dasClient.AsynchQuery(ADQL, format,
										args[4]);
								try {
	                                System.out.println("it is Serializing and writing to file ");
									String endpointString = ObjectSerializer
											.toString(Connect.dasClient
															.getinstanceEPR(),
													DASNamespaces.RESOURCE_REFERENCE);
									FileWriter fileWriter = new FileWriter(
											args[5]);
									BufferedWriter bfWriter = new BufferedWriter(
											fileWriter);
									bfWriter.write(endpointString);
									bfWriter.close();
								} catch (SerializationException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
	System.out.println("it have submitted!")	;						
							} catch (RemoteException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						} else
							System.out.println("the file does not exist!");
					} else
						System.out.println("it is error!");
				}
			}else System.out.println("the server is not connected");
		}

		//		
		// DocumentBuilderFactory jobFactory = DocumentBuilderFactory
		// .newInstance();
		// DocumentBuilder jobBuilder = jobFactory.newDocumentBuilder();
		// Document jobDoc = jobBuilder.parse("epr1.xml");
		// String sessionID = jobDoc.getFirstChild().getChildNodes().item(3)
		// .getChildNodes().item(1).getTextContent();
		//
		// System.out.println(sessionID);
	}

	public void dataurl(String[] args) throws DeserializationException,
			IOException {
		// get EPT to new dasClient
		if (args.length == 2) {
			if (args[1].toLowerCase().equals("-help")) {
				String dataURLnHelp = "usage: dataurl <fileName>\n"
						+ "Each option explained below:\n"
						+ "  fileName        -- it was specified by asyn command \n ";

				System.out.println(dataURLnHelp);
			} else {
				File f = new File(args[1]);
				if (f.exists()) {
					FileInputStream fis = new FileInputStream(args[1]);
					EndpointReferenceType instanceEPR = (EndpointReferenceType) ObjectDeserializer
							.deserialize(new InputSource(fis),
									EndpointReferenceType.class);
					fis.close();
					try {
					Properties props = new Properties();
					FileInputStream in = new FileInputStream("server.properties");
					props.load(in);
					in.close();

					String serverIP = props.getProperty("das.server");
					String port = props.getProperty("das.port");
			      
					Connect doConnect = new Connect(serverIP, port);
					int connected = doConnect.isConnect();
					if (connected == 1) {	
						dasClient = new DASClient(instanceEPR);
						try {
							String dataURL = dasClient.getTargetURL();
							System.out.println(dataURL);
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}else System.out.println("the server is not connected");
					} catch (ServiceException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
				
				}
				} else
					System.out.println("it is error!");
			}
		} else
			System.out.println("the number of the parameter is error!");

	}

	public void jobstatus(String args[]) throws DeserializationException,
			IOException {
		if (args.length == 2) {
			if (args[1].toLowerCase().equals("-help")) {
				String dataURLnHelp = "usage: jobstatus <fileName>\n"
						+ "Each option explained below:\n"
						+ "  fileName        -- it was specified by asyn command\n ";

				System.out.println(dataURLnHelp);
				
			} else {
				File f = new File(args[1]);
				if (f.exists()) {
					FileInputStream fis = new FileInputStream(args[1]);
					EndpointReferenceType instanceEPR = (EndpointReferenceType) ObjectDeserializer
							.deserialize(new InputSource(fis),
									EndpointReferenceType.class);
					fis.close();
					try {
						
						Properties props = new Properties();
						FileInputStream in = new FileInputStream("server.properties");
						props.load(in);
						in.close();

						String serverIP = props.getProperty("das.server");
						String port = props.getProperty("das.port");
				      
						Connect doConnect = new Connect(serverIP, port);
						int connected = doConnect.isConnect();
						if (connected == 1) {	
						dasClient = new DASClient(instanceEPR);
						try {
							String jobStatus = dasClient.getStatus();
							System.out.println(jobStatus);
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						}System.out.println("the server is not connected");
					} catch (ServiceException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				} else
					System.out.println("it is error!");
			}
		} else
			System.out.println("the number of the parameter is error!");

	}

	public void destroy(String[] args) throws DeserializationException,
			IOException {
		if (args.length == 2) {
			if (args[1].toLowerCase().equals("-help")) {
				String dataURLnHelp = "usage: destory <fileName>\n"
						+ "Each option explained below:\n"
						+ "  fileName        -- it was specified by asyn command and  saved the query object\n ";

				System.out.println(dataURLnHelp);
			} else {
				File f = new File(args[1]);
				if (f.exists()) {
					FileInputStream fis = new FileInputStream(args[1]);
					EndpointReferenceType instanceEPR = (EndpointReferenceType) ObjectDeserializer
							.deserialize(new InputSource(fis),
									EndpointReferenceType.class);
					fis.close();
					try {
						Properties props = new Properties();
						FileInputStream in = new FileInputStream("server.properties");
						props.load(in);
						in.close();

						String serverIP = props.getProperty("das.server");
						String port = props.getProperty("das.port");
				      
						Connect doConnect = new Connect(serverIP, port);
						int connected = doConnect.isConnect();
						if (connected == 1) {	
						dasClient = new DASClient(instanceEPR);
						try {
							String tmpStatus = dasClient.getStatus()
									.toLowerCase();
							if (tmpStatus.equals("processing")
									| tmpStatus.equals("waiting")) {
								dasClient.destroy();
								System.out.println("the job is destroyed");
							} else
								System.out.println("the job is not running ");
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						}else System.out.println("the server is not connected");
					} catch (ServiceException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				} else
					System.out.println("it is error");
			}
		} else
			System.out.println("the number of the parameter is error!");

	}
}
