package DAS;


import java.io.FileInputStream;
import java.io.StringReader;
import java.rmi.RemoteException;
import java.util.Properties;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.rpc.ServiceException;
import org.apache.axis.types.URI.MalformedURIException;
import org.china.vo.das.engine.client.DASClient;
import org.china.vo.das.engine.impl.DASNamespaces;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;

public class Md {
	private DASClient dasClient;
	private Document sourceDocument, tableDocument, columnDocument;

	private int sourceNumber = 0, tableNumber = 0, columnNumber = 0;

	private int sourcePropertiyNumber, tablePropertiyNumber,
			columnPropertiyNumber;

	private String sourceDescription = null, tableDescription = null,
			columnDescription = null;

	private String resource[][], table[][], column[][];

	public void showMeta(String args[]) throws Exception {
		String resource[][], table[][], column[][];
		String[] tmpResource, tmpTable, tmpColumn, tmpProperty;
		Element childResource, childTable, childColumn;
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document doc = builder.newDocument();
		Element rootElement = doc.createElement("metadata");
		doc.appendChild(rootElement);
		Properties props = new Properties();
		FileInputStream in = new FileInputStream("server.properties");
		props.load(in);
		in.close();

		String serverIP = props.getProperty("das.server");
		String port = props.getProperty("das.port");
		String factoryURI = serverIP+":"+port + "/wsrf/services/DASFactoryService";
		String instanceURI = serverIP+":"+port+ "/wsrf/services/DASService";
		
		if (args.length == 2) {
			if (args[1].toLowerCase().equals("-help")) {
				String asynHelp = "usage: md [-r <resourceName>  [-t <tableName>  [-c <columnName>] ] ]\n"
						+ "Each option explained below:\n"
						+ "no option          -- show all resource metadata \n "
						+ "-all              -- show all metadata  \n"
						+ " -r <resourceName>  -- show specified resource \n"
						+ " -t <tableName>     -- show specified resource and table \n"
						+ " -c <columnName>    -- show specified resource ,table and column \n";

				System.out.println(asynHelp);
			} else if(args[1].toLowerCase().equals("-all")){
				try {
					dasClient = new DASClient(factoryURI, instanceURI);	
					dasClient.updateRP(DASNamespaces.RP_STATUS,"FirstClient");
				    int connected =1;
				resource = getResource();
               // System.out.println("resource:"+resource.length);
				for (int i = 0; i < resource.length; i++) {

					tmpResource = resource[i][0].split("&");
					String resouceNode = tmpResource[0];
					String resourceName = tmpResource[1];
					childResource = doc.createElement("Resource");
					childResource.setAttribute("Name", resourceName);
					for (int i1 = 1; i1 < resource[i].length; i1++) {
						tmpProperty = resource[i][i1].split("&");
						childResource.setAttribute(tmpProperty[0],
								tmpProperty[1]);
					}
					rootElement.appendChild(childResource);

					table = getTable(resourceName);
					for (int j = 0; j < table.length; j++) {
						tmpTable = table[j][0].split("&");
						String tableNode = tmpTable[0];
						String tableName = tmpTable[1];
						childTable = doc.createElement("Table");
						childTable.setAttribute("Name", tableName);
						for (int j1 = 1; j1 < table[j].length; j1++) {
							tmpProperty = table[j][j1].split("&");
							childTable.setAttribute(tmpProperty[0],
									tmpProperty[1]);
						}
						childResource.appendChild(childTable);
						column = getColumn(resourceName, tableName);
						for (int k = 0; k < column.length; k++) {
							childColumn = doc.createElement("Column");
							for (int k1 = 0; k1 < column[k].length; k1++) {
								tmpProperty = column[k][k1].split("&");
								if (tmpProperty.length == 1) {
									childColumn.setAttribute(
											tmpProperty[0], "");
								} else {
									childColumn.setAttribute(
											tmpProperty[0], tmpProperty[1]);
								}
							}
							childTable.appendChild(childColumn);
						}
					}
				}
				String mdResult = ObjectSerializer.toString(doc,
						DASNamespaces.RESOURCE_REFERENCE);
				System.out.println(mdResult);
			}  catch (MalformedURIException e) {
				//	e.printStackTrace();
				System.out.println("malformed URLs");
				
			} catch (RemoteException e) {
				e.printStackTrace();
				System.out.println("remote connection is error");
				
			} catch (ServiceException e) {
				System.out.println("the service is an exception");
				
			} catch (Exception e) {
				System.out.println("connection is error");
				
			}
			}else
				System.out.println("the parameter is error");

		} else {
			
			try {
				dasClient = new DASClient(factoryURI, instanceURI);	
				dasClient.updateRP(DASNamespaces.RP_STATUS,"FirstClient");
			    int connected =1;
			  if (connected == 1) {
				if (args.length == 1) {
					
					resource = getResource();
					for (int i = 0; i < resource.length; i++) {

						tmpResource = resource[i][0].split("&");
						String resouceNode = tmpResource[0];
						String resourceName = tmpResource[1];
						childResource = doc.createElement("Resource");
						childResource.setAttribute("Name", resourceName);
						for (int i1 = 1; i1 < resource[i].length; i1++) {
							tmpProperty = resource[i][i1].split("&");
							childResource.setAttribute(tmpProperty[0],
									tmpProperty[1]);
						}
						rootElement.appendChild(childResource);

       }					
				} else if (args.length >= 3) {
					if (args[1].toLowerCase().equals("-r")) {
						resource = getResource();
						int i = 0;
						for (i = 0; i < resource.length; i++) {
							tmpResource = resource[i][0].split("&");
							String resouceNode = tmpResource[0];
							String resourceName = tmpResource[1];
							if (args[2].equals(resourceName))
								break;
						}
						if (i == resource.length)
							System.out.println("the resource is not existed!");
						else {
							childResource = doc.createElement("Resource");
							for (int i1 = 0; i1 < resource[i].length; i1++) {
								tmpResource = resource[i][i1].split("&");
								childResource.setAttribute(tmpResource[0],
										tmpResource[1]);
							}
							rootElement.appendChild(childResource);
							if (args.length == 4)
								System.out
										.println("It should be an another paparameter");
							if (args.length >= 5) {
								if (args[3].toLowerCase().equals("-t")) {
									table = getTable(args[2]);
									int j = 0;
									for (j = 0; j < table.length; j++) {
										tmpTable = table[j][0].split("&");
										String tableNode = tmpTable[0];
										String tableName = tmpTable[1];
										if (args[4].equals(tableName))
											break;
									}
									if (j == table.length)
										System.out
												.println("the table is not existed!");
									else {

										childTable = doc.createElement("Table");
										for (int j1 = 0; j1 < table[j].length; j1++) {
											tmpTable = table[j][j1].split("&");
											childTable.setAttribute(
													tmpTable[0], tmpTable[1]);
										}
										childResource.appendChild(childTable);

										if (args.length == 6)
											System.out
													.println("It should be an another parameter");
										if (args.length >= 7) {
											if (args[5].toLowerCase().equals(
													"-c")) {
												column = getColumn(args[2],
														args[4]);
												int k = 0;
												for (k = 0; k < column.length; k++) {
													tmpProperty = column[k][0]
															.split("&");
													if (args[6]
															.equals(tmpProperty[1]))
														break;
												}
												if (k == column.length)
													System.out
															.println("the column is not existed");
												else {
													childColumn = doc
															.createElement("Column");
													for (int k1 = 0; k1 < column[k].length; k1++) {
														tmpProperty = column[k][k1]
																.split("&");
														if (tmpProperty.length == 1)
															childColumn
																	.setAttribute(
																			tmpProperty[0],
																			"");
														else
															childColumn
																	.setAttribute(
																			tmpProperty[0],
																			tmpProperty[1]);
													}
													childTable
															.appendChild(childColumn);
												}
											} else
												System.out
														.println("It should be -c");
										}
									}
								} else
									System.out.println("It should be -t");
							}
						}

					} else
						System.out.println("It should be -r");

				} else
					System.out.println("it is error!");
			String mdResult = ObjectSerializer.toString(doc,
					DASNamespaces.RESOURCE_REFERENCE);
			System.out.println(mdResult);
			}else System.out.println("the server is not connected");

			}  catch (MalformedURIException e) {
			//	e.printStackTrace();
			System.out.println("malformed URLs");
			
		} catch (RemoteException e) {
			e.printStackTrace();
			System.out.println("remote connection is error");
			
		} catch (ServiceException e) {
			System.out.println("the service is an exception");
			
		} catch (Exception e) {
			System.out.println("connection is error");
			
		}
		}
	}

	// TransformerFactory tFactory = TransformerFactory.newInstance();
	// Transformer transformer = tFactory.newTransformer();
	// DOMSource source = new DOMSource(doc);
	// File f = new File("c:\\test.xml");
	// StreamResult result = new StreamResult(f);
	// transformer.transform(source, result);
	// PrintWriter pw = new PrintWriter(new FileOutputStream("c:\\test.xml"));
	// pw.println();

	public String[][] getResource() {
		
		String allResource;
		try {
			allResource = dasClient.getAllResource();
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			sourceDocument = dbf.newDocumentBuilder().parse(
					new InputSource(new StringReader(allResource)));
			sourceNumber = sourceDocument.getFirstChild().getChildNodes()
					.getLength();
			sourcePropertiyNumber = sourceDocument.getFirstChild()
					.getChildNodes().item(0).getChildNodes().getLength();
			resource = new String[sourceNumber][sourcePropertiyNumber];
			String sourceProptyName;
			for (int i = 0; i < sourceNumber; i++) {
				sourcePropertiyNumber = sourceDocument.getFirstChild()
						.getChildNodes().item(i).getChildNodes().getLength();
				for (int i1 = 0; i1 < sourcePropertiyNumber; i1++) {
					sourceProptyName = sourceDocument.getFirstChild()
							.getChildNodes().item(i).getChildNodes().item(i1)
							.getNodeName();
					sourceDescription = sourceDocument.getFirstChild()
							.getChildNodes().item(i).getChildNodes().item(i1)
							.getTextContent();
					resource[i][i1] = sourceProptyName + "&"
							+ sourceDescription;
				}

			}
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return resource;
	}

	public String[][] getTable(String sourceName) {

		String allResourceTable;
		try {
			allResourceTable = dasClient.getMetaTables(sourceName);
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			tableDocument = dbf.newDocumentBuilder().parse(
					new InputSource(new StringReader(allResourceTable)));
			tableNumber = tableDocument.getFirstChild().getChildNodes()
					.getLength();
			tablePropertiyNumber = tableDocument.getFirstChild()
					.getChildNodes().item(0).getChildNodes().getLength();
			table = new String[tableNumber][tablePropertiyNumber];
			for (int j = 0; j < tableNumber; j++) {

				for (int j1 = 0; j1 < tablePropertiyNumber; j1++) {
					String tableProptyName = tableDocument.getFirstChild()
							.getChildNodes().item(j).getChildNodes().item(j1)
							.getNodeName();
					tableDescription = tableDocument.getFirstChild()
							.getChildNodes().item(j).getChildNodes().item(j1)
							.getTextContent();
					table[j][j1] = tableProptyName + "&" + tableDescription;
				}
			}
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
		return table;
	}

	public String[][] getColumn(String sourceName, String tableName) {
		String allResourceTableColumn;
		try {
			allResourceTableColumn = dasClient.getMetaColumns(
					sourceName, tableName);
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			columnDocument = dbf.newDocumentBuilder().parse(
					new InputSource(new StringReader(allResourceTableColumn)));
			columnNumber = columnDocument.getFirstChild().getChildNodes()
					.getLength();
			columnPropertiyNumber = columnDocument.getFirstChild()
					.getChildNodes().item(0).getChildNodes().getLength();
			column = new String[columnNumber][columnPropertiyNumber];
			for (int k = 0; k < columnNumber; k++) {
				for (int k1 = 0; k1 < columnPropertiyNumber; k1++) {
					String columnPropertyName = columnDocument.getFirstChild()
							.getChildNodes().item(k).getChildNodes().item(k1)
							.getNodeName();
					columnDescription = columnDocument.getFirstChild()
							.getChildNodes().item(k).getChildNodes().item(k1)
							.getTextContent();
					column[k][k1] = columnPropertyName + "&"
							+ columnDescription;
				}
			}

		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// throw new RuntimeException(e.getMessage());
		}
		return column;
	}

	private Document parsexmldocument(String xmlstring) {
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			return dbf.newDocumentBuilder().parse(
					new InputSource(new StringReader(xmlstring)));

		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}

	}

}