package DAS;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
import java.net.URL;

/**
 * @author Haijun Tian 2008-4-16
 *
 */

public class Spectrum {
	private Document doc = null;
	private String  sourceFile,desDirectory;
	public Spectrum(String[] args){
		if(args.length>=5){
		this.sourceFile = args[2] ;
		this.desDirectory = args[4] ;
		}
	}
   
	/**
	 * @param xmlFile
	 * @throws Exception
	 * initialize the xml file, loading the xml file into Memory
	 */
	public void init(String xmlFile) throws Exception {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		doc = db.parse(new File(xmlFile));
	}
   public void download(String[] args) throws Exception{
	   if(args.length==2){
		  if(args[1].toLowerCase().equals("-help")){
			  String downHelp = "usage: downspec <-f <sorurceVOTFile>> <-d <destinationDirectory>> \n"
					+ "Each option explained below:\n"
					+ "  downspec            --  the command downloads files from the specified path in sourceVOTFile file to destinationDirectory directory \n "
					+ " -f <sourceVOTFile>    -- sourceVOTFile is the file specified by asyn command as saving result data.\n" 
					+ "  -d <destinationDirectory>  -- the destination directory of downloading file.\n";			
			System.out.println(downHelp);
		  }else
			  System.out.println("syntax is error ");
	   }else if(args.length==5){
		   this.sourceFile = args[2];
	    	this.desDirectory = args[4];
	    	System.out.println(args[1]);
	    	System.out.println(args[3]);
	    	if(args[1].toLowerCase().equals("-f")& args[3].toLowerCase().equals("-d")){
			   // Spectrum parse = new Spectrum();	
				getAllSpectrums(sourceFile);
				System.out.println("filednum: " + findSpecPath());
	    	}else
	    		System.out.println("syntax is error ");
	   }else
		   System.out.println("syntax is error ");
   }
	/**
	 * @param xmlFile
	 * @throws Exception
	 * get the spectrum files through the URLs from xmlFile
	 */
	public void getAllSpectrums(String xmlFile) throws Exception {
		this.init(xmlFile);
		int fieldID = -1; // FieldID of Spectrum Path, -1 means no SpecPath Field
		fieldID = this.findSpecPath();
		NodeList nodeList = doc.getElementsByTagName("TR");

		for (int k = 0; k < nodeList.getLength(); k++) {

			Node fatherNode = nodeList.item(k);
			NodeList childNodes = fatherNode.getChildNodes(); //some child is fakement, which may be Enter value
			int fieldID2 = 0; //which identifies ID of the right child
			for (int j = 0; j < childNodes.getLength(); j++) {

				Node childNode = childNodes.item(j);

				/*
				 * עdomXMLʱÿеĻسҲɸĺ
				 * 
				 */
				if (childNode.getNodeType() == Node.ELEMENT_NODE) {

					String specURL = null;
					if (fieldID == fieldID2) {
						specURL = childNode.getFirstChild().getNodeValue();
						this.getSpec(specURL);
					}
					fieldID2++;
				}				

			}

		}
	}

	/**
	 * @get the ID of Spec Path Field
	 */
	public int findSpecPath() {

		int fieldnum = -1;
		NodeList nodeList = doc.getElementsByTagName("FIELD");
		for (int i = 0; i < nodeList.getLength(); i++) {
			Node fatherNode = nodeList.item(i);
			NamedNodeMap attributes = fatherNode.getAttributes();
			for (int j = 0; j < attributes.getLength(); j++) {
				Node attribute = attributes.item(j);
				if (attribute.getNodeValue().equals("meta.ref.uri.spec")) {
					fieldnum = i;
					System.out.println("fieldnum in findSpecPath:" + fieldnum);
				}
			}
		}
		System.out.println("nodeList's length :" + nodeList.getLength());
		return fieldnum;
	}

	/**
	 * @param specURL
	 * download the Spec file from the SpecURL
	 */
	public void getSpec(String specURL) {
	//	System.out.println("specURL:"+specURL);
		try {
			String[] st = specURL.split("/");
			String specname = st[st.length - 1];
			//System.out.println("specname:" + specname);
			if((new File(specname)).exists()){
	              System.err.println("Compress: won't overwrite existing file: "+specname);
	                return; 
			}else{
				System.out.println("desDirectory:"+desDirectory);
				System.out.println("sourceFile:"+sourceFile);
			FileOutputStream fos = new FileOutputStream(desDirectory+specname,true); //don't cover the exist
			System.out.println(specURL);
			URL url = new URL(specURL);
			InputStream is = url.openStream();
			byte b[] = new byte[40960];
			System.out.print("Downloading the Spectrum: " + specname + "\n" + "Please wait");
			while (true) {
				int i = is.read(b);
				if (i == -1)
					break;
				fos.write(b);
				
				System.out.print("..");
			}
			fos.close();
			//System.out.println("Finished downloading the Specturm: " + specname);
		}} catch (Exception ex) {
			ex.printStackTrace();
		}
		
	}


}
