package DAS;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.StringReader;
import java.rmi.RemoteException;
import java.util.Properties;

import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class Syn {
	private int format;

	private String ADQL, result, synResult = "";

	public void synQ(String[] args) throws IOException,
			ParserConfigurationException, SAXException {
		if (args.length == 2) {
			if (args[1].toLowerCase().equals("-help")) {
			String synHelp = "usage: syn <adql|-f <adql file>> <format> \n"
					+ "Each option explained below:\n"
					+ "  adql          --  the adql query sentence submitted by user\n "
					+ " -f <adqlFile> -- the text file containning adql query sentence\n"
					+ "  format        -- one of 0,1,2,3 \n"
					+ "                 0 : CSV with comma\n"
					+ "                 1 : CSV with TAB\n "
					+ "                2 : VOTable \n "
					+ "                3 : FITS \n";
			System.out.println(synHelp);
			}else System.out.println("the parameter is error");
		} else {
			Properties props = new Properties();
			FileInputStream in = new FileInputStream("server.properties");
			props.load(in);
			in.close();

			String serverIP = props.getProperty("das.server");
			String port = props.getProperty("das.port");

			Connect doConnect = new Connect(serverIP, port);
			int connected = doConnect.isConnect();
			if (connected == 1) {
				if (args.length == 3) {

					if (args[2].equals("0") | args[2].equals("1")
							| args[2].equals("2") | args[2].equals("3")) {

						format = Integer.parseInt(args[2]);
						ADQL = args[1];

						result = Connect.dasClient.synchQuery(ADQL, format);
						if (result.length() == 0) {
							System.out.println("the result is null");
						} else {
							Document synResultDocument = parsexmldocument(result);
							int resultNumber = synResultDocument
									.getFirstChild().getChildNodes()
									.getLength();

							for (int k = 9; k < resultNumber; k++) {
								String resultList = synResultDocument
										.getFirstChild().getChildNodes()
										.item(k).getTextContent();
								synResult = synResult + resultList + "\n";
							}
							System.out.println(synResult);
						}
					} else {
						System.out.println("it is error");
					}
				} else if (args.length == 4) {
					if (args[1].toLowerCase().endsWith("-f")) {
						String readStr = "", read;
						if (args[3].equals("0") | args[3].equals("1")
								| args[3].equals("2") | args[3].equals("3"))
							format = Integer.parseInt(args[3]);
						File file = new File(args[2]);
						if (file.exists()) {
							try {

								FileReader fileread = new FileReader(file);
								BufferedReader bufread = new BufferedReader(
										fileread);
								while ((read = bufread.readLine()) != null) {
									readStr = readStr + read;
								}
							} catch (Exception d) {
							}
							ADQL = readStr;
							try {
								result = Connect.dasClient.synchQuery(ADQL,
										format);
								if (result.length() == 0) {
									System.out.println("the result is null");
								} else {
									Document synResultDocument = parsexmldocument(result);
									int resultNumber = synResultDocument
											.getFirstChild().getChildNodes()
											.getLength();

									for (int k = 9; k < resultNumber; k++) {
										String resultList = synResultDocument
												.getFirstChild()
												.getChildNodes().item(k)
												.getTextContent();
										synResult = synResult + resultList
												+ "\n";
									}
									System.out.println(synResult);
								}
							} catch (RemoteException e) {
								e.printStackTrace();
							}
						} else
							System.out.println("the file does not exist!");
					} else
						System.out.println("it is error!");
				} else
					System.out.println("it is error!");
			} else
				System.out.println("the server is not connected");
		}
	}

	private Document parsexmldocument(String xmlstring) {
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			return dbf.newDocumentBuilder().parse(
					new InputSource(new StringReader(xmlstring)));

		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
	}
}
