package DAS;
import java.rmi.RemoteException;
import javax.xml.rpc.ServiceException;
//import org.apache.axis.types.URI.MalformedURIException;
import org.china.vo.das.engine.client.DASClient;
import org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType;
import org.oasis.wsrf.properties.ResourceUnknownFaultType;
import org.apache.axis.message.addressing.EndpointReferenceType;

public class Job{
	private String jobID;
    private String taskName;
    private String queryString;
    private String status;
    private String submitTime;
    private String startTime;
    private String finishTime;
    private String DASURL;
    private String DataURL;
    private int format;
 
    private String eprDirectory;
    private EndpointReferenceType EPR;
    private String synResult ;
    private int queryType;
    
    //SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"); 
 	
     public Job() {
		// TODO Auto-generated constructor stub
	 }
 	
     //call this new Job when user submits query
    public Job(String taskName,String queryString,String status,String submitTime,int format,String URL,int queryType) {    	
    	this.jobID=String.valueOf(++Main_frame.jobID);
    	this.taskName = taskName;
    	this.queryString = queryString;
    	this.status = status;
        this.submitTime = submitTime;
    	this.startTime = " ";
    	this.finishTime = " ";
    	this.DASURL = "http://192.168.3.3";
    	if (queryType==0){
    		this.DataURL = URL;
    	}else
    	{
    		this.DataURL = " ";
    	}
    	
    	this.format = format;
    	this.queryType = queryType;    	
	    this.EPR = Main_frame.mConnectDialog.getDasClient().getinstanceEPR();
		this.eprDirectory = "job\\epr" + this.jobID+".dat" ;
    }	
    
	public void AsynchRun() {

    	try {  		   		
    		 SubmitButtonListener.dasClient.AsynchQuery(queryString, format, DataURL);  	
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}  	
	}
	public String synRun() {	
	    		try {
	    			synResult =   Main_frame.mConnectDialog.getDasClient().synchQuery(queryString, format);
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return synResult ;
			 	
	}
	
	public void finish(DASClient dasClient) {
		
		try {
		   	
	    	//this.finishTime = dasClient.getEndTime(); 

			this.DataURL = dasClient.getTargetURL();
			dasClient.destroy();
		} catch (InvalidResourcePropertyQNameFaultType e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ResourceUnknownFaultType e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			
		}
	}

	public  String getJobState(DASClient dasClient){
		try {
			status = dasClient.getStatus();

		} catch (InvalidResourcePropertyQNameFaultType e) {
			e.printStackTrace();
		} catch (ResourceUnknownFaultType e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}	
		return status;
	}

	public int getQueryType(){
		return this.queryType;
	}

	public String getDASURL() {
		return DASURL;
	}

	public void setDASURL(String dasurl) {
		DASURL = dasurl;
	}

	public String getDataURL() {
		return DataURL;
	}

	public void setDataURL(String dataURL) {
		DataURL = dataURL;
	}

	public String getFinishTime() {
		return finishTime;
	}

	public void setFinishTime(String finishTime) {
		this.finishTime = finishTime;
	}

	public int getFormat() {
		return format;
	}

	public void setFormat(int format) {
		this.format = format;
	}

	public String getJobID() {
		return jobID;
	}

	public void setJobID(String jobID) {
		this.jobID = jobID;
	}

	public String getQueryString() {
		return queryString;
	}

	public void setQueryString(String queryString) {
		this.queryString = queryString;
	}

	public String getStartTime() {
		return startTime;
	}

	public void setStartTime(String startTime) {
		this.startTime = startTime;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getSubmitTime() {
		return submitTime;
	}

	public void setSubmitTime(String submitTime) {
		this.submitTime = submitTime;
	}

	public String getTaskName() {
		return taskName;
	}

	public void setTaskName(String taskName) {
		this.taskName = taskName;
	}
	
	public String getEprDirectory() {
		return eprDirectory;
	}

	public void setEprDirectory(String eprDirectory) {
		this.eprDirectory = eprDirectory;
	}
	
	public EndpointReferenceType getEPR() {
		return EPR;
	}
	public void setEPR(EndpointReferenceType EPR) {
		this.EPR = EPR;
	}
}

