package DAS;
import java.util.ArrayList;
import java.util.Collection;

import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.JToolTip;

import java.awt.Component;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.MouseEvent  ; 
public class JobListManager {
	private static JobListManager jobListManager=null;
	public static ArrayList <Job> jobList=new ArrayList<Job>();
	public static ArrayList<Job> historyList = new ArrayList<Job>();
	
	private static String[] stateTitle = {"jobID","TaskName","QueryString","Status","SubmitTime","StartTime","DASURL","DataURL","Operation"};
	private static String[] historyTitle = {"jobID","TaskName","QueryString","Status","SubmitTime","StartTime","FinishTime","DataURL","DASURL"};
    private static String[][] stateTableData =null  ;
    private static String[][] historyTableData = null ;
    private static int close ;
    
    public static CellEditDisabledTableModel  stateModel = new CellEditDisabledTableModel(stateTableData,stateTitle); 
    public static JTable stateTable = new JTable(stateModel){   
        public   JToolTip   createToolTip()   {   
            JobMultiLineToolTip   tip   =   new   JobMultiLineToolTip();   
            tip.setComponent(this);   
            return   tip;   
        }   
    };   
    
    public static DefaultTableModel  historyModel = new  DefaultTableModel(historyTableData,historyTitle);
	public static JTable historyTable = new JTable(historyModel);
	private  int x , y;
	public  static String taskName,queryString,dataURL;
	
	private boolean ALLOW_ROW_SELECTION = true ;

	JobListManager() {
  
    	stateTable.setRowSelectionAllowed(true);     	
    	stateTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION) ;
    	
    	historyTable.setRowSelectionAllowed(true);     	
    	historyTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION) ;
    	 
    	
    	
    	if (ALLOW_ROW_SELECTION) { // true by default
            ListSelectionModel rowSM = stateTable.getSelectionModel();
            rowSM.addListSelectionListener(new ListSelectionListener() {
            	
                public void valueChanged(ListSelectionEvent e) {
                    //Ignore extra messages.
                    if (e.getValueIsAdjusting()) return;
                    
                    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                 //   System.out.println(e.getSource());
                    if(e.getSource() instanceof JButton){
                    	
                    
                    if (!lsm.isSelectionEmpty()) {
                        int selectedRow = lsm.getMinSelectionIndex();
                        
                        stateTable.setToolTipText(
                        		"JobID:"+
                        		stateTable.getValueAt(selectedRow, 0).toString()+"\n"+
                        		"TaskName:"+
                        		stateTable.getValueAt(selectedRow, 1).toString()+"\n"+                    		
                        		"QueryString:"+ 
                        		stateTable.getValueAt(selectedRow, 2).toString()+"\n"+                       		
                        		"Status:"+
                        		stateTable.getValueAt(selectedRow, 3).toString()+"\n"+
                        		"SubmitTime:"+
                        		stateTable.getValueAt(selectedRow, 4).toString()+"\n"+
                        		"StartTime:"+
                        		stateTable.getValueAt(selectedRow, 5).toString()+"\n"+
                        		"DASURL:"+
                        		stateTable.getValueAt(selectedRow, 6).toString()+"\n"+
                        		"DataURL:"+
                        		stateTable.getValueAt(selectedRow, 7).toString()
                        		);
                        		
                    }
                }
                }
            });
        } else {
        	stateTable.setRowSelectionAllowed(false);
        }
    	 
        if (ALLOW_ROW_SELECTION) { // true by default
            ListSelectionModel rowSM = historyTable.getSelectionModel();
            
            rowSM.addListSelectionListener(new ListSelectionListener() {
            	
                public void valueChanged(ListSelectionEvent e) {
                    //Ignore extra messages.
                    if (e.getValueIsAdjusting()) return;
                    
                    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                    if (!lsm.isSelectionEmpty()) {
                    	 x = historyTable.getMousePosition().x;
                    	 y = historyTable.getMousePosition().y;        
                    	 
                        int selectedRow = lsm.getMinSelectionIndex();
                        taskName = historyTable.getValueAt(selectedRow, 1).toString();                       
                        queryString = historyTable.getValueAt(selectedRow, 2).toString();
                        dataURL = historyTable.getValueAt(selectedRow, 7).toString();

                       
                        final HistoryInfo historyInfo = new HistoryInfo ();   
                        historyInfo.setBounds(x+250, y+265, 402, 252);
                        historyInfo.setVisible(true);
                        
						    JTextArea historyTextArea = historyInfo.getJTextAreaHistory();
						    historyTextArea.setText("JobID:"+
                        		historyTable.getValueAt(selectedRow, 0).toString()+"\n"+
                        		"TaskName:"+
                        		historyTable.getValueAt(selectedRow, 1).toString()+"\n"+
                        		"QueryString:"+
                        		historyTable.getValueAt(selectedRow, 2).toString()+"\n"+
                        		"Status:"+
                        		historyTable.getValueAt(selectedRow, 3).toString()+"\n"+
                        		"SubmitTime:"+
                        		historyTable.getValueAt(selectedRow, 4).toString()+"\n"+
                        		"StartTime:"+
                        		historyTable.getValueAt(selectedRow, 5).toString()+"\n"+
                        		"FinishTime:"+
                        		historyTable.getValueAt(selectedRow, 6).toString()+"\n"+
                        		"DataURL:"+
                        		historyTable.getValueAt(selectedRow, 7).toString()+"\n"+
                        		"DASURL:"+
                        		historyTable.getValueAt(selectedRow, 8).toString());
						    
   
                    }
                }
            });
        } else {
        	historyTable.setRowSelectionAllowed(false);
        }

	}

	public void setJobList(ArrayList<Job> jobList) {
		this.jobList = jobList;
	}
	
	public ArrayList<Job> getJobList() {
		return jobList;
	}
   
	public void setHistoryList(ArrayList<Job> historyList) {
		this.historyList = historyList;
	}
	
	public ArrayList<Job> getHistoryList() {
		return historyList;
	}
}
