package DAS;

//package DAS;
import java.awt.*;
import javax.swing.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.china.vo.das.engine.impl.DASNamespaces;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.encoding.SerializationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.Map;

public class Main_frame extends JFrame {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static InterfaceDesign mInterfaceDesign = null;
	public static connectDialog mConnectDialog = null;
	public static int queryType = 0 ;//querytype=0 means AsynchronousQuery query
	                                 //  querytype=1 means SynchronousQuery query
	public static int jobID = 0 ;
	public static int isConnected =0 ;
	public static JobListManager jobListManager = new JobListManager();
	public static Main_frame framework;
	public static JobMonitor jobMonitor = new JobMonitor();
	//public static int jobNum  
	public Main_frame() throws IOException, ParserConfigurationException, SAXException{
	  doShutDownWork();
	}
	
	//writing the JobList content to xml files when the application exit 
	private void doShutDownWork(){
	Runtime.getRuntime().addShutdownHook(new Thread(){	
		      public void run() {
		    	String[] jobListname = new String[9];
		  		jobListname[0] = "jobID";
		  		jobListname[1] = "taskName";
		  		jobListname[2] = "queryString";
		  		jobListname[3] = "state";
		  		jobListname[4] = "submitTime";
		  		jobListname[5] = "startTime";
		  		jobListname[6] = "DASURL";
		  		jobListname[7] = "DataURL";  
		  		jobListname[8] = "eprDirectory";
		  		
		  		String jobRootName = "Job";

				try {
					DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
					DocumentBuilder builder = factory.newDocumentBuilder();
					org.w3c.dom.Document doc ;
					Element rootElement ;
					
					TransformerFactory formFactory = TransformerFactory.newInstance();
					Transformer transFormer = formFactory.newTransformer();
					
					
					Element[] childElement =new Element[9];
					Text[] textNode = new Text[9];

					for(Job job : Main_frame.jobListManager.getJobList()){	
					
						doc=builder.newDocument();
						rootElement = doc.createElement(jobRootName);
						doc.appendChild(rootElement);				
						
					    textNode[0] = doc.createTextNode(job.getJobID());
					    textNode[1] = doc.createTextNode(job.getTaskName());
					    textNode[2] = doc.createTextNode(job.getQueryString());
					    textNode[3] = doc.createTextNode(job.getStatus());
					    textNode[4] = doc.createTextNode(job.getSubmitTime());
					    textNode[5] = doc.createTextNode(job.getStartTime());
					    textNode[6] = doc.createTextNode(job.getDASURL());
					    textNode[7] = doc.createTextNode(job.getDataURL());
					    textNode[8] = doc.createTextNode(job.getEprDirectory());
					    
					    for(int j =0 ; j < 9; j++){
					       childElement[j] = doc.createElement(jobListname[j]);
					       rootElement.appendChild(childElement[j]);
					       childElement[j].appendChild(textNode[j]);
					    } 
						
						Result output = new StreamResult(new File("job\\job"+(job.getJobID())+".xml"));
						DOMSource source = new DOMSource(doc);
						transFormer.transform(source, output);	
 
						try {
							String endpointString = ObjectSerializer.toString(job.getEPR(), DASNamespaces.RESOURCE_REFERENCE);
							FileWriter fileWriter = new FileWriter(job.getEprDirectory());
					    	BufferedWriter bfWriter = new BufferedWriter(fileWriter);
					    	bfWriter.write(endpointString);
					    	bfWriter.close();
						} catch (SerializationException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
					}
					

				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (TransformerConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (TransformerException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

               
				String[] historyListname = new String[9];
				historyListname[0] = "jobID";
				historyListname[1] = "taskName";
				historyListname[2] = "queryString";
				historyListname[3] = "state";
				historyListname[4] = "submitTime";
				historyListname[5] = "startTime";
				historyListname[6] = "finishTime";
				historyListname[7] = "DataURL";  
				historyListname[8] = "DASURL";
		  		
		  		String historyRootName = "History";

				try {
					DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
					DocumentBuilder builder = factory.newDocumentBuilder();
					org.w3c.dom.Document doc;
					Element rootElement ;
					
					TransformerFactory formFactory = TransformerFactory.newInstance();
					Transformer transFormer = formFactory.newTransformer();
					
					
					Element[] childElement =new Element[9];
					Text[] textNode = new Text[9];
					for(Job history : Main_frame.jobListManager.getHistoryList()){	
					
						doc=builder.newDocument();
						rootElement = doc.createElement(historyRootName);
						doc.appendChild(rootElement);				
						
					    textNode[0] = doc.createTextNode(history.getJobID());
					    textNode[1] = doc.createTextNode(history.getTaskName());

					    textNode[2] = doc.createTextNode(history.getQueryString());
					    textNode[3] = doc.createTextNode(history.getStatus());
					    textNode[4] = doc.createTextNode(history.getSubmitTime());
					    textNode[5] = doc.createTextNode(history.getStartTime());
					    textNode[6] = doc.createTextNode(history.getFinishTime());
					    textNode[7] = doc.createTextNode(history.getDataURL());
					    textNode[8] = doc.createTextNode(history.getDASURL());
					    
					    for(int j =0 ; j < 9; j++){
					       childElement[j] = doc.createElement(historyListname[j]);
					       rootElement.appendChild(childElement[j]);
					       childElement[j].appendChild(textNode[j]);
					    } 
						String fileName = "history\\history"+(history.getJobID())+".xml";
                        if (!new File(fileName).exists()){
							Result output = new StreamResult(new File(fileName));
							DOMSource source = new DOMSource(doc);
							transFormer.transform(source, output);	
                        }
					}
					

				} catch (ParserConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (TransformerConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (TransformerException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
//				} catch (FileNotFoundException e) {
//					// TODO Auto-generated catch block
//					e.printStackTrace();
//				} catch (IOException e) {
//					// TODO Auto-generated catch block
//					e.printStackTrace();
			}
				
		      }		      
		     });

		
	}
	
	public static void main(String[] args) throws IOException, ParserConfigurationException, SAXException {
						
		Main_frame framework = new Main_frame();
		framework.setTitle("ChinaVODAS");
		framework.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container content = framework.getContentPane();
		content.setLayout(new BorderLayout());
		mInterfaceDesign = new InterfaceDesign();
		
		//show the menubar and toolbar
		JPanel mPanel = new JPanel();
		JMenuBar VODASMenuBar = mInterfaceDesign.createMenuBar();
		JToolBar VODASToolBar = mInterfaceDesign.createToolBar();
		mPanel.setLayout(new BorderLayout());		
		mPanel.add(VODASMenuBar,BorderLayout.NORTH);
		mPanel.add(VODASToolBar,BorderLayout.SOUTH);
		content.add(mPanel,BorderLayout.NORTH);
		mPanel.setBorder(BorderFactory.createEtchedBorder());
		//VODASToolBar.addMouseListener(new TreeListener());
	   
		//show the tree
		JScrollPane mTree = new JScrollPane();
		String a[] = {""};
		
		mTree.getViewport().add(mInterfaceDesign.createTree(a),BorderLayout.CENTER);
		mTree.setPreferredSize(new Dimension(250, 700));
		content.add(mTree,BorderLayout.WEST);
		Main_frame.mInterfaceDesign.getTree().addMouseListener(new TreeMouseListener());
	
		//show the two tabbedpane 
		JPanel sPanel = new JPanel();		
		content.add(sPanel,BorderLayout.CENTER);
		sPanel.setLayout(new BorderLayout());
		
		JPanel sPanel_1 = new JPanel();
	    sPanel_1.setLayout(new BorderLayout());	   
	    sPanel_1.add(mInterfaceDesign.createQueryTabbedPane(),BorderLayout.NORTH);
	    sPanel_1.add(mInterfaceDesign.createSouthPanel(),BorderLayout.SOUTH);
	   
	    
	    sPanel.add(sPanel_1,BorderLayout.NORTH);
	    sPanel.add(mInterfaceDesign.createShowTabbedPane(),BorderLayout.SOUTH);
	    
		//shwo the stateTest
		content.add(mInterfaceDesign.createTextField(),BorderLayout.SOUTH);
		mInterfaceDesign.createPopUpMenu();
		
		framework.setSize(1024, 735);
		framework.setVisible(true);
		
		Main_frame.framework=framework;
		
		
	}

}

