package DAS;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;
import javax.xml.rpc.ServiceException;
import org.china.vo.das.engine.client.DASClient;
import org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType;
import org.oasis.wsrf.properties.ResourceUnknownFaultType;

public class JobMonitor extends Thread {
	private String newState;

	private Job job;

	private String tmpStartTime;

	@Override
	public void run() {
		Iterator itr;
		while (true) {

			itr = new ArrayList(Main_frame.jobListManager.getJobList())
					.iterator();
			synchronized (JobListManager.stateModel) {
				while (itr.hasNext()) {
					job = (Job) itr.next();
					DASClient dasClient = null;
					Object jobID = "";
					int n = -2;
					try {
						dasClient = new DASClient(job.getEPR());
						newState = job.getJobState(dasClient);
						int i = JobListManager.stateModel.getRowCount();
						for (int m = 0; m < i; m++) {
							jobID = JobListManager.stateModel.getValueAt(m, 0);
							if (jobID.equals((Object) job.getJobID())) {
								n = m;
								break;
							}
						}
					} catch (ServiceException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					if (n != -2) {
						JobListManager.stateModel.setValueAt(newState, n, 3);
						if (((newState.equals("Processing") || newState
								.equals("PROCESSING")))
								&& job.getStartTime() == " ") {
							try {
								tmpStartTime = dasClient.getStartTime();
								JobListManager.stateModel.setValueAt(
										tmpStartTime, n, 5);
								job.setStartTime(tmpStartTime);
							} catch (InvalidResourcePropertyQNameFaultType e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							} catch (ResourceUnknownFaultType e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							} catch (RemoteException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							} catch (Exception e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}

						}
						if ((newState.equals("Completed")
								|| newState.equals("COMPLETED")
								|| newState.equals("Error") || newState
								.equals("ERROR"))) {
							job.setStatus(newState);
							job.finish(dasClient);

							//update joblist and histroylist	        
							Main_frame.jobListManager.getHistoryList().add(job);
							Main_frame.jobListManager.getJobList().remove(job);
							//itr.remove();   

							//update state table and history table
							JobListManager.stateModel.removeRow(n);
							Vector historyRowData = new Vector(9);
							historyRowData.setSize(9);
							historyRowData.setElementAt(job.getJobID(), 0);
							historyRowData.setElementAt(job.getTaskName(), 1);
							historyRowData
									.setElementAt(job.getQueryString(), 2);
							historyRowData.setElementAt(job.getStatus(), 3);
							historyRowData.setElementAt(job.getSubmitTime(), 4);
							historyRowData.setElementAt(job.getStartTime(), 5);
							historyRowData.setElementAt(job.getFinishTime(), 6);
							historyRowData.setElementAt(job.getDataURL(), 7);
							historyRowData.setElementAt(job.getDASURL(), 8);
							connectDialog.historyModel.addRow(historyRowData);

							JobListManager.stateTable.repaint();
							JobListManager.stateTable.updateUI();
							JobListManager.historyTable.repaint();
							JobListManager.historyTable.updateUI();

						}

					}
				}
			}
			try {
				sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

	}

}
